cbuffer CBuffer0
{
	matrix WVPMatrix;	// 64 bytes
	float4 directional_light_vector; // 16
	float4 directional_light_colour; // 16
	float4 ambient_light_colour; // 16
};

struct VOut
{
	float4 position : SV_POSITION;
	float4 color : COLOR;
	float2 texcoord : TEXCOORD;
};

Texture2D texture0;
SamplerState sampler0;

VOut VShader(float4 position : POSITION, float4 color : COLOR, float2 texcoord : TEXCOORD, float3 normal : NORMAL)
{
	VOut output;

	output.position = mul(WVPMatrix, position);	

	float diffuse_amount = dot(directional_light_vector, normal);
	diffuse_amount = saturate(diffuse_amount);

	output.color = color * (ambient_light_colour + (directional_light_colour * diffuse_amount));
	output.texcoord = texcoord;

	return output;
}

float4 PShader(float4 position : SV_POSITION, float4 color : COLOR, float2 texcoord : TEXCOORD) : SV_TARGET
{
	//color *= texture0.Sample(sampler0, texcoord);

	return color;
}
